<?php
// $Id: theme-settings.php,v 1.1 2010/11/23 19:39:43 gjmjr Exp $

/**
 * Implementation of THEMEHOOK_settings() function.
 *
 * @param $saved_settings
 *   array An array of saved settings for this theme.
 * @return
 *   array A form array.
 */
function mo6_settings($saved_settings) {
  $settings = theme_get_settings('mo6');

  $form['mo6_compactcomments'] = array(
    '#type' => 'checkbox',
    '#title' => t('Use a compact comment form for anonymous users'),
    '#default_value' => $settings['mo6_compactcomments'],
  );
  $form['header'] = array(
    '#type' => 'fieldset',
    '#title' => t('Custom header image'),
    '#description' => t('Image is displayed on top and bottom of every page'),
  );
  $form['header']['mo6_use_header'] = array(
    '#type' => 'checkbox',
    '#title' => t('Use a custom header image'),
    '#default_value' => $settings['mo6_use_header'],
  );
  $form['header']['mo6_header_path'] = array(
    '#type' => 'textfield',
    '#title' => t('Path to custom header image'),
    '#default_value' => $settings['mo6_header_path'],
  );

  $form['header']['mo6_header_upload'] = array(
    '#type' => 'file',
    '#title' => t('Upload header image'),
    '#description' => t('For best results use an image with a width of 770 pixels and a height of 150 pixels'),
  );
  $form['#submit'][] = 'mo6_settings_submit';
  $form['header']['mo6_header_upload']['#element_validate'][] = 'mo6_settings_submit';

  return $form;
}

/**
 * Capture theme settings submissions and update uploaded image
 */
function mo6_settings_submit($form, &$form_state) {
  // Check for a new uploaded file, and use that if available.
  if ($file = file_save_upload('mo6_header_upload')) {
    $parts = pathinfo($file->filename);
    $filename = (! empty($key)) ? str_replace('/', '_', $key) .'_header.'. $parts['extension'] : 'mo6_header.'. $parts['extension'];

    // The image was saved using file_save_upload() and was added to the
    // files table as a temporary file. We'll make a copy and let the garbage
    // collector delete the original upload.
    if (file_copy($file, $filename)) {
      $_POST['mo6_use_header'] = $form_state['values']['mo6_use_header'] = TRUE;
      $_POST['mo6_header_path'] = $form_state['values']['mo6_header_path'] = $file->filepath;
    }
  }
}
